# -*- coding: utf-8 -*-
# An enhancement to check if a Duo Admin has changed his/her own password (opposed to another user)
from elastalert.enhancements import BaseEnhancement
from elastalert.enhancements import DropMatchException
from elastalert.util import lookup_es_key


class DuoPasswordChange(BaseEnhancement):
    def process(self, match):
        password = None
        obj = lookup_es_key(match, 'duo_data.object')
        username = lookup_es_key(match, 'duo_data.username')
        description = lookup_es_key(match, 'duo_data.description')

        if description:
            password = description.get('password')
        if any(value is None for value in [obj, username, password]):
            return
        if password == "<new password>" and obj == username:
            raise DropMatchException()
