# -*- coding: utf-8 -*-
# An enhancement for adding a link to virustotal for blocked domains in FIREHOL MALWARE alerts
import ast

from elastalert.enhancements import BaseEnhancement


class virustotal_link(BaseEnhancement):
    def process(self, match):
        url = 'https://www.virustotal.com/en/ip-address/%s/information/'
        for dest in match.get('top_events_firehol.ip_address_dst', {}).keys():
            link = None
            if dest:
                # Sometimes the hostname is of the form "['1.2.3.4', 'hostname.domain.com']"
                if dest[0] == '[':
                    link = url % (ast.literal_eval(dest)[0])
                else:
                    link = url % (dest)
            if not link:
                continue
            match['top_events_firehol.ip_address_dst'][dest] = str(match['top_events_firehol.ip_address_dst'][dest]) + '\n' + link + '\n'
